//+------------------------------------------------------------------+
//|                                                   ICWR Color     |
//+------------------------------------------------------------------+
#property copyright "ICWR Color"
#property link      "ICWR Color"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 MidnightBlue

//---- indicator parameters
extern int ExtDepth=12;
extern int ExtDeviation=5;
extern int ExtBackstep=3;
extern int RequiredWaveHeight=40;

//---- indicator buffers
double ExtMapBuffer[];
double ExtMapBuffer2[];
double Fibo1=0;
double Fibo2=0;
double Fibo3=0;
double Fibo4=0;
double Fibo5=0;
double Fibo6=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(2);

//---- drawing settings
   SetIndexStyle(0,DRAW_SECTION);
   
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(0,0.0);
   ArraySetAsSeries(ExtMapBuffer,true);
   ArraySetAsSeries(ExtMapBuffer2,true);
   
//---- indicator short name
   IndicatorShortName("ICWR("+ExtDepth+","+ExtDeviation+","+ExtBackstep+")");

//---- initialization done
   return(0);
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()                           
{                                 
                                    
   ObjectDelete("ActiveWave");
   ObjectDelete("Fibo1");
   ObjectDelete("Fibo2");
   ObjectDelete("Fibo3");
   ObjectDelete("Fibo4");
   ObjectDelete("Fibo5");
   ObjectDelete("Fibo6");
   
   return(0);
}

//+------------------------------------------------------------------+
//| Main function                                                    |
//+------------------------------------------------------------------+
int start()
{
   int    shift,back,lasthighpos,lastlowpos,LastActivePos;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow,LastActive;
   
   int AWStartPos, AWEndPos;
   double AWStart, AWEnd;
   
   double FiboL, FiboH, FiboLC, FiboLR, FiboHR, FiboHC;

   for(shift=Bars-ExtDepth; shift>=0; shift--)
   {
                                      
                                      
      val=Low[Lowest(NULL,0,MODE_LOW,ExtDepth,shift)];
                                      
      
      if(val==lastlow)           
         val=0.0;              
      
      else                         
      { 
         lastlow=val;                  
         if((Low[shift]-val)>(ExtDeviation*Point)) 
            val=0.0;                   
                                      
         
         else                         
         {                           
            for(back=1; back<=ExtBackstep; back++)
            {                      
                                      
               res=ExtMapBuffer[shift+back];
               if((res!=0)&&(res>val)) 
                  ExtMapBuffer[shift+back]=0.0; 
            }
         }
      } 

      ExtMapBuffer[shift]=val;    
                                      
      val=High[Highest(NULL,0,MODE_HIGH,ExtDepth,shift)];

      if(val==lasthigh) 
         val=0.0;
      else 
      {
         lasthigh=val;
         if((val-High[shift])>(ExtDeviation*Point)) 
            val=0.0;
         else
         {
            for(back=1; back<=ExtBackstep; back++)
            {
               res=ExtMapBuffer2[shift+back];
               if((res!=0)&&(res<val)) 
                  ExtMapBuffer2[shift+back]=0.0; 
            } 
         }
      }
      ExtMapBuffer2[shift]=val;
   }

   // final cutting 
   lasthigh=-1; 
   lasthighpos=-1;
   lastlow=-1;  
   lastlowpos=-1;

   for(shift=Bars-ExtDepth; shift>=0; shift--)
   {
      curlow=ExtMapBuffer[shift];
      curhigh=ExtMapBuffer2[shift];
      
      if((curlow==0)&&(curhigh==0))
         continue;                   
      
      if(curhigh!=0)               
      {
         if(lasthigh>0)             
         {
            if(lasthigh<curhigh)         
               ExtMapBuffer2[lasthighpos]=0;
            else                        
               ExtMapBuffer2[shift]=0;
         }
         
         if(lasthigh<curhigh || lasthigh<0)
         {                             
            lasthigh=curhigh;         
            lasthighpos=shift;      
         }
         lastlow=-1;              
      }

      if(curlow!=0)          
      {
         if(lastlow>0)
         {
            if(lastlow>curlow) 
               ExtMapBuffer[lastlowpos]=0;
            else 
               ExtMapBuffer[shift]=0;
         }

         if((curlow<lastlow)||(lastlow<0))
         {
            lastlow=curlow;
            lastlowpos=shift;
         } 
         lasthigh=-1;
      }
   }
  
   for(shift=Bars-1; shift>=0; shift--)
   {                               
      if(shift>=Bars-ExtDepth)   
         ExtMapBuffer[shift]=0.0; 
      else
      {                          
         res=ExtMapBuffer2[shift];   
         if(res!=0.0)              
            ExtMapBuffer[shift]=res;
      }                           
   }                              

   LastActive = -1;
   LastActivePos = -1;
      
   for(shift=0; shift<=Bars-ExtDepth; shift++)
   {
      if(ExtMapBuffer[shift]!=0.0)
      {
         if(LastActive > 0)
         {
            if(MathAbs(LastActive - ExtMapBuffer[shift]) >= RequiredWaveHeight*Point)
            {
               AWStartPos = shift;
               AWStart = ExtMapBuffer[shift];
               AWEndPos = LastActivePos;
               AWEnd = LastActive;
 //======================================================================================              

               if(ObjectFind("ActiveWave") != 0)
               {
                  ObjectCreate("ActiveWave", OBJ_TREND, 0, Time[AWStartPos], AWStart, Time[AWEndPos], AWEnd);
                  ObjectSet("ActiveWave", OBJPROP_STYLE, STYLE_SOLID);
                  ObjectSet("ActiveWave", OBJPROP_COLOR, White); //Red              
                  ObjectSet("ActiveWave", OBJPROP_WIDTH, 3);
                  ObjectSet("ActiveWave", OBJPROP_RAY, false);  
               }
               else
               {
                  ObjectMove("ActiveWave", 0, Time[AWStartPos], AWStart);
                  ObjectMove("ActiveWave", 1, Time[AWEndPos], AWEnd);
               }
            
               if(AWStart < AWEnd)
               {
                  FiboL = AWStart;
                  FiboH = AWEnd;
               }
               else
               {
                  FiboL = AWEnd;
                  FiboH = AWStart;
               }
               
        
//======================================================================================            
            
        if(ObjectFind("Fibo1") != 0)
               {
                  ObjectCreate("Fibo1", OBJ_FIBO, 0, Time[AWStartPos], AWStart, Time[AWEndPos], AWEnd);
                  ObjectSet("Fibo1", OBJPROP_STYLE, STYLE_SOLID);
                  ObjectSet("Fibo1", OBJPROP_COLOR, RosyBrown);               
                  ObjectSet("Fibo1", OBJPROP_WIDTH, 2);
                  ObjectSet("Fibo1", OBJPROP_FIBOLEVELS, 1);
                  ObjectSet("Fibo1", OBJPROP_FIRSTLEVEL+0, 0);
               }
               else
               {
                  ObjectMove("Fibo1", 0, Time[AWStartPos], AWStart);
                  ObjectMove("Fibo1", 1, Time[AWEndPos], AWEnd);
               }
 //=======================================              
               
         if(ObjectFind("Fibo2") != 0)
               {
                  ObjectCreate("Fibo2", OBJ_FIBO, 0, Time[AWStartPos], AWStart, Time[AWEndPos], AWEnd);
                  ObjectSet("Fibo2", OBJPROP_STYLE, STYLE_SOLID);
                  ObjectSet("Fibo2", OBJPROP_COLOR, Lime);  // Gold             
                  ObjectSet("Fibo2", OBJPROP_WIDTH, 2);
                  ObjectSet("Fibo2", OBJPROP_FIBOLEVELS, 2);
                  ObjectSet("Fibo2", OBJPROP_FIRSTLEVEL+1, 0.236); 
               }
                 else
               {
                   ObjectMove("Fibo2", 0, Time[AWStartPos], AWStart);
                   ObjectMove("Fibo2", 1, Time[AWEndPos], AWEnd);
               }
              
 //=========================================             
        if(ObjectFind("Fibo3") != 0)
               {
                  ObjectCreate("Fibo3", OBJ_FIBO, 0, Time[AWStartPos], AWStart, Time[AWEndPos], AWEnd);
                  ObjectSet("Fibo3", OBJPROP_STYLE, STYLE_SOLID);
                  ObjectSet("Fibo3", OBJPROP_COLOR, Aqua);                
                  ObjectSet("Fibo3", OBJPROP_WIDTH, 2);
                  ObjectSet("Fibo3", OBJPROP_FIBOLEVELS, 3);
                  ObjectSet("Fibo3", OBJPROP_FIRSTLEVEL+1, 0.382); 
               }
                 else
               {
                   ObjectMove("Fibo3", 0, Time[AWStartPos], AWStart);
                   ObjectMove("Fibo3", 1, Time[AWEndPos], AWEnd);
               }
               
//============================================               
               if(ObjectFind("Fibo4") != 0)
               {
                  ObjectCreate("Fibo4", OBJ_FIBO, 0, Time[AWStartPos], AWStart, Time[AWEndPos], AWEnd);
                  ObjectSet("Fibo4", OBJPROP_STYLE, STYLE_SOLID);
                  ObjectSet("Fibo4", OBJPROP_COLOR, Aqua);               
                  ObjectSet("Fibo4", OBJPROP_WIDTH, 2);
                  ObjectSet("Fibo4", OBJPROP_FIBOLEVELS, 4);
                  ObjectSet("Fibo4", OBJPROP_FIRSTLEVEL+1, 0.618); 
               }
                 else
               {
                   ObjectMove("Fibo4", 0, Time[AWStartPos], AWStart);
                   ObjectMove("Fibo4", 1, Time[AWEndPos], AWEnd);
               }
               
//==============================================               
               if(ObjectFind("Fibo5") != 0)
               {
                  ObjectCreate("Fibo5", OBJ_FIBO, 0, Time[AWStartPos], AWStart, Time[AWEndPos], AWEnd);
                  ObjectSet("Fibo5", OBJPROP_STYLE, STYLE_SOLID);
                  ObjectSet("Fibo5", OBJPROP_COLOR, Lime);  // Gold               
                  ObjectSet("Fibo5", OBJPROP_WIDTH, 2);
                  ObjectSet("Fibo5", OBJPROP_FIBOLEVELS, 5);
                  ObjectSet("Fibo5", OBJPROP_FIRSTLEVEL+1, 0.764);  
               }
                 else
               {
                   ObjectMove("Fibo5", 0, Time[AWStartPos], AWStart);
                   ObjectMove("Fibo5", 1, Time[AWEndPos], AWEnd);
               }
               
 //==============================================              
               if(ObjectFind("Fibo6") != 0)
               {
                  ObjectCreate("Fibo6", OBJ_FIBO, 0, Time[AWStartPos], AWStart, Time[AWEndPos], AWEnd);
                  ObjectSet("Fibo6", OBJPROP_STYLE, STYLE_SOLID);
                  ObjectSet("Fibo6", OBJPROP_COLOR, RosyBrown);               
                  ObjectSet("Fibo6", OBJPROP_WIDTH, 2);
                  ObjectSet("Fibo6", OBJPROP_FIBOLEVELS, 3);
                  ObjectSet("Fibo6", OBJPROP_FIRSTLEVEL+1, 1.0); 
               }
                 else
               {
                   ObjectMove("Fibo6", 0, Time[AWStartPos], AWStart);
                   ObjectMove("Fibo6", 1, Time[AWEndPos], AWEnd);
               }
       
//=================================================               
               break;
            }
         }
         LastActive = ExtMapBuffer[shift];
         LastActivePos = shift;
      }
   }
}





                 
                  
                  
                  
                  